function hl2::create( ) {

	// health, energy
	vhud::create( "hl2health", "15% 8%", "1% 93%", hl2health::onrender );
	vhud::add_item( "pixelsize_numbers", "45%" );
	vhud::add_item( "label_value", "58% 20%" );
	vhud::add_item( "pixelsize_text", "40%" );
	vhud::add_item( "label_text", "43% 15%" );
	vhud::duplicate( "hl2health", "hl2energy", "18% 93%", hl2energy::onrender );

	// ammo, beacons, grenades and mines
	vhud::create( "hl2mine", "15% 8%", "50% 94%", hl2mine::onrender );
	vhud::add_item( "pixelsize_text", "17%" );
	vhud::add_item( "pixelsize_numbers", "25%" );
	vhud::add_item( "label_text", "0% 22%" );
	vhud::add_item( "label_value", "0% 40%" );
	vhud::duplicate( "hl2mine", "hl2nade", "48% 94%", hl2nade::onrender );
	vhud::duplicate( "hl2mine", "hl2beacon", "46% 94%", hl2beacon::onrender );
	vhud::create( "hl2ammo", "19% 8%", "34% 94%", hl2ammo::onrender );
	vhud::add_item( "pixelsize_numbers", "65%" );
	vhud::add_item( "label_value", "10% 10%" );

	// fps, speed
	vhud::create( "hl2fps", "15% 8%", "69% 5%", hl2fps::onrender );
	vhud::add_item( "pixelsize_text", "15%" );
	vhud::add_item( "pixelsize_numbers", "30%" );
	vhud::add_item( "label_text", "0% 0%" );
	vhud::add_item( "label_value", "15% 5%" );
	vhud::add_item( "label_text2", "50% 0%" );
	vhud::add_item( "label_value2", "65% 5%" );

	// flags
	vhud::create( "hl2flage", "20% 8%", "54% 96.5%", "hl2flag::onrender(Team::Enemy());" );
	vhud::add_item( "pixelsize_text", "25%" );
	vhud::add_item( "label_text", "5% 10%" );
	vhud::add_item( "label_value", "15% 10%" );
	vhud::duplicate( "hl2flage", "hl2flagf", "54% 94%", "hl2flag::onrender(Team::Friendly());" );

	// health bar, energy bar
	vhud::create( "hl2health_bar", "15% 3%", "0.5% 97%", "hl2bar::onrender($Health,health);" );
	vhud::add_item( "label_bar_topleft", "5% 30%" );
	vhud::add_item( "label_bar_bottomright", "95% 70%" );
	vhud::duplicate( "hl2health_bar", "hl2energy_bar", "17.5% 97%", "hl2bar::onrender($Energy,energy);" );
	vhud::create( "hl2black", "16% 8%", "0% 94%", hl2black::onrender );
	vhud::duplicate( "hl2black", "hl2black2", "17% 94%", hl2black::onrender );

	// fullscreen dummy container so we can adjust the radar based on resolution
	vhud::create( "fullscreen", "100% 100%", "0 0", fullscreen::onrender );
	vhud::add_item( "radar_width", "20%" );
	vhud::add_item( "radar_zoom", "100%" );

}

// hud code

function fullscreen::onrender( ) {
	$pref::radarWidth = ( vhud::render_value( "radar_width" ) );
	$pref::radarZoom = ( 3000 / vhud::render_value( "radar_zoom" ) );
	%x = ( getword( vhud::render_value( "size" ), 0 ) - $pref::radarWidth );
	Control::setPosition( compassHud, %x - 16, 0 );
	Control::setPosition( clockHud, 10, 10 );
}


function hl2hud::backdrop( ) {
	glDisable( $GL_TEXTURE_2D );
	glBlendFunc( $GL_SRC_ALPHA, $GL_ONE_MINUS_SRC_ALPHA );

	glColor4ub( 0, 0, 0, 128 );
	vhud::render_box( "pos", "size" );
}

function hl2black::onrender( ) {
	hl2hud::backdrop( );
}

function hl2bar::onrender( %percentage, %type ) {
	%topleft = ( vhud::render_value( "label_bar_topleft" ) );
	%bottomright = ( vhud::render_value( "label_bar_bottomright" ) );
	
	%x = ( getword( %topleft, 0 ) ); 
	%y = ( getword( %topleft, 1 ) );
	
	%width = ( getword( %bottomright, 0 ) - %x );
	%height = ( getword( %bottomright, 1 ) - %y );
	
	%percentage /= 100;
	%pixel_width = ( %width * %percentage );

	if ( %type == energy ) {
		glColor4ub( 0, 255, 255, 196 );
	} else if ( %type == health ) {
		if ( %percentage > 0.700001 )
			glColor4ub( 0, 220, 0, 192 );
		else if ( %percentage > 0.30001 )
			glColor4ub( 255, 255, 0, 192 );
		else if ( %percentage > 0.00001 )
			glColor4ub( 255, 0, 0, 192 );
		else
			glColor4ub( 0, 0, 0, 192 );
	} else {
		glColor4ub( 255, 224, 0, 192 );
	}
		
	glRectangle( %x, %y, %pixel_width, %height );
	if ( %pixel_width < %width ) {
		%x += %pixel_width;
		glColor4ub( 128, 128, 128, 64 );
		glRectangle( %x, %y, %width - %pixel_width, %height );
	}
}

function hl2health::onrender( ) {
	%percentage = ( $Health / 100 );
	if ( %percentage < 0.30001 ) {
		glColor4ub( 255, 0, 0, 192 );
	} else if ( %percentage < 0.70001 ) {
		glColor4ub( 255, 255, 0, 192 );
	}
	else
		glColor4ub( 0, 220, 0, 192 );
		vhud::render_text( "label_value", $font, "pixelsize_numbers", $GLEX_SMOOTH, $Health );
		if ( (GetItemCount("repair kit") == 1) && ( %percentage < 0.80001 ) && ( %percentage > 0 ) ) {
			use("repair kit");
		} else if ( GetItemCount("repair kit") == 1 ) {
			glColor4ub( 255, 255, 255, 192 );
			vhud::render_text( "label_text", "Arial Black", "pixelsize_text", $GLEX_SMOOTH, "+" );
		} else { }
}

function hl2energy::onrender( ) {
	if ($blasterdrop == "1") { 
		if (GetItemCount(blaster)) {
		drop("Blaster");
			if (GetItemCount("Disc Launcher") && GetItemCount("Disc") > 0) {
			use("Disc Launcher");
			} else {
			NextWeapon();
			}
		}
	}
	glColor4ub( 0, 237, 223, 196 );
	vhud::render_text( "label_value", $font, "pixelsize_numbers", $GLEX_SMOOTH, $Energy );
}

function hl2ammo::onrender( ) {
	hl2hud::backdrop( );
	if ( $Ammo < 0 )
		return;
	if ( $Ammo != 0 ) {
		%r = 255; %g = 255; %b = 255; %a = 192;
	} else {
		%r = 255; %g = 0; %b = 0; %a = 192;
		nextWeapon();
	}
	glColor4ub( %r, %g, %b, %a );
	vhud::render_text( "label_value", $font, "pixelsize_numbers", $GLEX_SMOOTH, $Ammo );
}

function hl2fps::onrender( ) {
	if($showfps=="1") {
	$fps = floor($ConsoleWorld::FrameRate);
 	glColor4ub( 0, 0, 0, 150 );
	vhud::render_text( "label_text", $font, "pixelsize_text", $GLEX_SMOOTH, "FPS" );
	vhud::render_text( "label_text2", $font, "pixelsize_text", $GLEX_SMOOTH, "SPD" );
 	glColor4ub( 255, 255, 255, 150 );
	vhud::render_text( "label_value", $font, "pixelsize_numbers", $GLEX_SMOOTH, $FPS );
	vhud::render_text( "label_value2", $font, "pixelsize_numbers", $GLEX_SMOOTH, $Speed );
	} else { }
}

function hl2flag::onrender( %team ) {
	if (%team == Team::Friendly()) 
	{
		hl2hud::backdrop( );
		glColor4ub( 255, 0, 0, 192 );
	}
	else
	{
		glColor4ub( 0, 200, 0, 192 );
	}
	%score = Team::Score(%team);
	%loc = Team::Flag::Location(%team);
	if (%loc == "home")
	{
		%loc = "Home";
		glColor4ub( 164, 164, 164, 75 );
	}
	else if (%loc == "field")
	{
		%loc = "Dropped - " @ Team::Flag::Timer(%team);
	}
	else
	{
		//replace "<" with  (aka char 215, which we edited to "<" in custom fonts)
		%loc = String::EscapeTags(Client::GetName(%loc));
	}
	vhud::render_text( "label_value", $font, "pixelsize_text", $GLEX_SMOOTH,  %loc );
	glColor4ub( 255, 255, 255, 192 );
	vhud::render_text( "label_text", $font, "pixelsize_text", $GLEX_SMOOTH,  %score );
}

function hl2mine::onrender( ) {
	$mines = GetItemCount(mine);
	if ($mines == 0 ) {
		%r = 164; %g = 164; %b = 164; %a = 75;
	} else {
		%r = 255; %g = 255; %b = 0; %a = 192;
	}
 	glColor4ub( %r, %g, %b, %a );
  	vhud::render_text( "label_text", $font, "pixelsize_text", $GLEX_SMOOTH, "M" );
	vhud::render_text( "label_value", $font, "pixelsize_numbers", $GLEX_SMOOTH, $mines );
}

function hl2nade::onrender( ) {
	$nades = GetItemCount(grenade);
	if ($nades == 0 ) {
		%r = 164; %g = 164; %b = 164; %a = 75;
	} else {
		%r = 255; %g = 255; %b = 0; %a = 192;
	}
 	glColor4ub( %r, %g, %b, %a );
  	vhud::render_text( "label_text", $font, "pixelsize_text", $GLEX_SMOOTH, "G" );
	vhud::render_text( "label_value", $font, "pixelsize_numbers", $GLEX_SMOOTH, $nades );
}

function hl2beacon::onrender( ) {
	$beacons = GetItemCount(beacon);
	if ($beacons == 0 ) {
		%r = 164; %g = 164; %b = 164; %a = 75;
	} else {
		%r = 255; %g = 255; %b = 0; %a = 192;
	}
 	glColor4ub( %r, %g, %b, %a );
  	vhud::render_text( "label_text", $font, "pixelsize_text", $GLEX_SMOOTH, "B" );
	vhud::render_text( "label_value", $font, "pixelsize_numbers", $GLEX_SMOOTH, $beacons );
}

hl2::create( );